#include <bits/stdc++.h>
using namespace std;
int main(){
long long n;
cin>>n;
long long niz[n-1],niz2[n-1],nizGdeSeJavljaS1[n-1],nizGdeSeJavljaS2[n-1],broj=0,brojS=0,brojO=0,x,y,u,z;
for(int i=0; i<n-2; i++) nizGdeSeJavljaS1[i]=0;
for(int i=0; i<n-2; i++) nizGdeSeJavljaS2[i]=0;
char niz3[n-1];
for(int i=0; i<n-1; ++i){
    cin>>niz[i]>>niz2[i]>>niz3[i];
}
for(int i=0; i<n-1; ++i){
    if(niz3[i]=='I'){
        for(int j=0; j<n-1; ++j){
            if((niz[j]==niz[i] || niz2[j]==niz[i] || niz2[j]==niz2[i] || niz[j]==niz2[i]) && niz3[j]=='S'){
                for(int k=0; k<n-1; ++k){
                    if((niz[k]!=niz[j] && niz2[k]!=niz[j] && niz2[k]!=niz2[j] && niz[k]!=niz2[j]) && niz3[k]=='O'){
                        broj++;
                    }
                }
            }
        }
    }
}
cout<<broj;
return 0;
}